<?php
declare(strict_types=1);

namespace App\Doctrine\Education;

use ApiPlatform\Metadata\Operation;
use App\Doctrine\AbstractExtension;
use App\Entity\Access\Access;
use App\Entity\Education\Cycle;
use Doctrine\ORM\QueryBuilder;
use Symfony\Bundle\SecurityBundle\Security;

/**
 * Class CurrentCycleExtension : Filtre de sécurité par défaut pour une resource Cycle
 * @package App\Doctrine\Core
 */
final class CurrentCycleExtension extends AbstractExtension
{
    public function __construct(private Security $security)
    { }

    public function supports(string $resourceClass, ?Operation $operation): bool {
        return $resourceClass === Cycle::class;
    }
    protected function addWhere(QueryBuilder $queryBuilder, string $resourceClass, ?Operation $operation): void
    {
        /** @var Access $currentUser */
        $currentUser = $this->security->getUser();
        $rootAlias = $queryBuilder->getRootAliases()[0];
        $queryBuilder
            ->andWhere(sprintf('%s.organization = :organization', $rootAlias))
            ->setParameter('organization', $currentUser->getOrganization())
        ;
    }
}
